Bug 1490733 - “ibus emoji” do not fit emoji descriptions and annotations with default Monospace
Summary: “ibus emoji” do not fit emoji descriptions and annotations with default Monos...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: ibus
Version: 27
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: fujiwara
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-09-12 07:14 UTC by Mike FABIAN
Modified: 2017-09-30 06:43 UTC (History)
4 users (show)

Fixed In Version: ibus-1.5.16-9.fc26 ibus-1.5.16-11.fc26 ibus-1.5.16-11.fc27
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-09-23 20:22:09 UTC
Type: Bug


Attachments (Terms of Use)
ibus-emoji.png (241.96 KB, image/png)
2017-09-12 07:14 UTC, Mike FABIAN
no flags Details
ibus-emoji.png (303.96 KB, image/png)
2017-09-15 11:58 UTC, Mike FABIAN
no flags Details

Description Mike FABIAN 2017-09-12 07:14:59 UTC
Created attachment 1324737 [details]
ibus-emoji.png

I am using Fedora-Workstation-netinst-x86_64-27-20170910.n.0.iso in qemu like this:

nice -n 19 ionice -c 3 qemu-kvm -machine pc-i440fx-2.4 -enable-kvm -global qxl.ram_size=1x1024 -m 2048M -smp 2 -drive file=./Fedora-Workstation-netinst-x86_64-27-20170910.n.0.iso.qcow2,index=0,media=disk,cache=unsafe -localtime -serial file:/tmp/qemu-Fedora-Workstation-netinst-x86_64-27-20170910.n.0.iso.qcow2-output.log -name Fedora-Workstation-netinst-x86_64-27-20170910.n.0.iso.qcow2 -cdrom /local/mfabian/iso/Fedora-27/Fedora-Workstation-netinst-x86_64-27-20170910.n.0.iso -boot c -spice port=6002,disable-ticketing,streaming-video=off -vga qxl -display vnc=:6 -net nic -net user,hostname=Fedora-Workstation-netinst-x86_64-27-20170910.n.0.iso.qcow2,hostfwd=tcp::5558-:22 -monitor stdio -usb -usbdevice mouse -soundhw all

ibus version is:

ibus-1.5.16-8.fc27.x86_64

I am using Gnome under wayland and start “ibus emoji” in a terminal
(Control+Shift+e does *not* show any emoji dialog. Therefore, I start it
from a terminal).

In the emoji selection dialog shown I click on “Activities”.

A surprising list of emoji is shown, most of them don’t seem to belong
to “Activities”.

At the top left I see a tree.

When I hover with the mouse over that tree, I see the description
“jack-o-lantern” below.

Then I click on that tree to select it and see the message
“Copied an emoji to your clipboard” in the terminal where I started “ibus emoji”.

Now I paste that emoji from the clipboard into gedit and I get
🎃 U+1F383 JACK-O-LANTERN in gedit.

The tree is just an example, this happens almost everywhere in
the emoji dialog, the emoji glyphs shown do not fit the
descriptions and annotations in most cases.

Comment 1 fujiwara 2017-09-14 06:38:57 UTC
Because the glyphs are derived from "Noto Emoji".
You can set "Noto Color Emoji" font with ibus-setup.
I will enhance a bit for the default font.

--- ibus-1.5.16/ui/gtk3/ibusfontset.c.orig	2017-09-13 18:58:44.358062155 +0900
+++ ibus-1.5.16/ui/gtk3/ibusfontset.c	2017-09-14 15:34:01.024597067 +0900
@@ -35,6 +35,9 @@
 #define UNKNOWN_FONT_SIZE 7
 #define IBUS_FONTSET_GET_PRIVATE(o)  \
    (G_TYPE_INSTANCE_GET_PRIVATE ((o), IBUS_TYPE_FONTSET, IBusFontSetPrivate))
+#define MONOSPACE "monospace"
+#define SERIF     "serif"
+#define SANS      "sans"
 
 
 static FT_Library  m_ftlibrary;
@@ -764,6 +767,12 @@ ibus_fontset_update_fcfontset (IBusFontS
     FcPatternAddInteger (pattern, FC_WEIGHT, FC_WEIGHT_NORMAL);
     FcPatternAddInteger (pattern, FC_WIDTH, FC_WIDTH_NORMAL);
     FcPatternAddInteger (pattern, FC_DPI, 96);
+    if (FC_VERSION >= 21205 &&
+        (!g_ascii_strncasecmp (family, MONOSPACE, strlen (MONOSPACE)) ||
+         !g_ascii_strncasecmp (family, SERIF, strlen (SERIF)) ||
+         !g_ascii_strncasecmp (family, SANS, strlen (SANS)))) {
+        FcPatternAddBool (pattern, FC_COLOR, TRUE);
+    }
     FcConfigSubstitute (NULL, pattern, FcMatchPattern);
     FcConfigSubstitute (NULL, pattern, FcMatchFont);
     FcDefaultSubstitute (pattern);

Comment 2 fujiwara 2017-09-14 07:11:22 UTC
I changed the intention of this report a little.

Comment 3 Fedora Update System 2017-09-14 10:51:08 UTC
ibus-1.5.16-9.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-ee7868ca2e

Comment 4 Fedora Update System 2017-09-14 10:51:34 UTC
ibus-1.5.16-9.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-7c8156fe9c

Comment 5 Fedora Update System 2017-09-14 18:22:50 UTC
ibus-1.5.16-9.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-7c8156fe9c

Comment 6 Fedora Update System 2017-09-15 04:52:21 UTC
ibus-1.5.16-9.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-ee7868ca2e

Comment 7 Mike FABIAN 2017-09-15 11:52:10 UTC
(In reply to Fedora Update System from comment #5)
> ibus-1.5.16-9.fc27 has been pushed to the Fedora 27 testing repository. If
> problems still persist, please make note of it in this bug report.
> See https://fedoraproject.org/wiki/QA:Updates_Testing for
> instructions on how to install test updates.
> You can provide feedback for this update here:
> https://bodhi.fedoraproject.org/updates/FEDORA-2017-7c8156fe9c

The problem still exists.

Comment 8 Mike FABIAN 2017-09-15 11:58:18 UTC
Created attachment 1326436 [details]
ibus-emoji.png

[mfabian@Fedora-Workstation-netinst-x86_6 ~]$ rpm -q ibus
ibus-1.5.16-9.fc27.x86_64
[mfabian@Fedora-Workstation-netinst-x86_6 ~]$

It does not matter whether Gnome or Xfce is used, it looks the same
in both.

Note that the glyphs of the emoji shown in ibus-ui-emojier are
partly in colour (apparently from the “Emoji One” font
and partly in black and white. The 🐭 U+1F42D for example seems
to come from  DejaVuSans.ttf.

Comment 9 Fedora Update System 2017-09-17 22:50:24 UTC
ibus-1.5.16-9.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Mike FABIAN 2017-09-18 12:32:57 UTC
The problem still exists.

Comment 11 fujiwara 2017-09-20 03:59:13 UTC
(In reply to Mike FABIAN from comment #8)
> Created attachment 1326436 [details]
> It does not matter whether Gnome or Xfce is used, it looks the same
> in both.

Thank you for the test.
Seems you use fontconfig 2.12.5 and the previous patch also expects 2.12.5 but koji still uses 2.12.4 .

I should use FcGetVersion() instead of FC_VERSION not to take the build version.

> 
> Note that the glyphs of the emoji shown in ibus-ui-emojier are
> partly in colour (apparently from the “Emoji One” font
> and partly in black and white. The 🐭 U+1F42D for example seems
> to come from  DejaVuSans.ttf.

It would be an expected result if a font does not have glyphs, another fallback font is chosen.

Comment 12 Fedora Update System 2017-09-20 05:26:21 UTC
ibus-1.5.16-10.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-9684858af6

Comment 13 Fedora Update System 2017-09-20 05:49:26 UTC
ibus-1.5.16-10.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-8603ec1846

Comment 14 Fedora Update System 2017-09-20 15:21:33 UTC
ibus-1.5.16-10.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-8603ec1846

Comment 15 Fedora Update System 2017-09-20 23:50:49 UTC
ibus-1.5.16-10.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-9684858af6

Comment 16 Fedora Update System 2017-09-21 05:54:58 UTC
ibus-1.5.16-11.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-8603ec1846

Comment 17 Fedora Update System 2017-09-21 05:55:30 UTC
ibus-1.5.16-11.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-9684858af6

Comment 18 Fedora Update System 2017-09-21 23:57:10 UTC
ibus-1.5.16-11.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-8603ec1846

Comment 19 Fedora Update System 2017-09-22 05:52:40 UTC
ibus-1.5.16-11.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-9684858af6

Comment 20 Fedora Update System 2017-09-23 20:22:09 UTC
ibus-1.5.16-11.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2017-09-30 06:43:34 UTC
ibus-1.5.16-11.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.